/* $Id: debug.h,v 1.1 2002/10/23 03:32:47 relson Exp $ */

#ifndef _DEBUG_H
#define _DEBUG_H

#ifdef	NODEBUG
typedef enum bit_e {DEBUG_NONE=0}  bit_t;
#else
#define MASKNAMES "gldsw"
typedef enum bit_e {DEBUG_NONE=0, BIT_GENERAL=1, BIT_LEXER=2, BIT_DATABASE=4, BIT_SPAMICITY=8, BIT_WORDLIST=16}  bit_t;
#endif

extern bit_t debug_mask;

#ifdef	NODEBUG
#define	DEBUG_GENERAL(level) 	0
#define DEBUG_SPAMICITY(level)	0
#define DEBUG_DATABASE(level)	0
#define DEBUG_LEXER(level)	0
#define DEBUG_WORDLIST(level)	0
#else
#define	DEBUG_GENERAL(level) 	((debug_mask & BIT_GENERAL)   && (verbose > level))
#define DEBUG_SPAMICITY(level)	((debug_mask & BIT_SPAMICITY) && (verbose > level))
#define DEBUG_DATABASE(level)	((debug_mask & BIT_DATABASE)  && (verbose > level))
#define DEBUG_LEXER(level)	((debug_mask & BIT_LEXER)     && (verbose > level))
#define DEBUG_WORDLIST(level)	((debug_mask & BIT_WORDLIST)  && (verbose > level))
#endif

void set_debug_mask( char *mask );

#endif
